/*
 * (C) 2007-2012 Alibaba Group Holding Limited.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * Authors:
 *   wuhua <wq163@163.com> , boyan <killme2008@gmail.com>
 */
package com.taobao.metamorphosis.client.consumer;

import java.util.Collection;
import java.util.concurrent.TimeUnit;

import com.taobao.metamorphosis.client.Shutdownable;
import com.taobao.metamorphosis.client.consumer.storage.OffsetStorage;
import com.taobao.metamorphosis.cluster.Partition;
import com.taobao.metamorphosis.exception.MetaClientException;


/**
 * Ϣߣ̰߳ȫƼ
 * 
 * @author boyan
 * @Date 2011-4-21
 * 
 */
public interface MessageConsumer extends Shutdownable {

    /**
     * ȡָtopicͷϢĬϳʱ10
     * 
     * @param topic
     * @param partition
     * @return ϢΪnull
     */
    public MessageIterator get(String topic, Partition partition, long offset, int maxSize) throws MetaClientException,
            InterruptedException;


    /**
     * ȡָtopicͷϢָʱûз׳쳣
     * 
     * @param topic
     * @param partition
     * @param timeout
     * @param timeUnit
     * @return ϢΪnull
     * @throws TimeoutException
     */
    public MessageIterator get(String topic, Partition partition, long offset, int maxSize, long timeout,
            TimeUnit timeUnit) throws MetaClientException, InterruptedException;


    /**
     * ָϢMessageListenerϢﵽʱ֪ͨMessageListenerע⣬
     * ô˷ʹĹϵЧ ֻڵcompleteЧ˷ʽ
     * 
     * @param topic
     *            ĵtopic
     * @param maxSize
     *            ÿνյݴС,ܳ1M
     * @param messageListener
     *            Ϣ
     */
    public MessageConsumer subscribe(String topic, int maxSize, MessageListener messageListener)
            throws MetaClientException;


    /**
     * Ϣ,ע⣬ô˷ʹĹϵЧֻڵcompleteЧ
     * 
     * @param subscriptions
     */
    public void setSubscriptions(Collection<Subscription> subscriptions) throws MetaClientException;


    /**
     * ʹѾĵtopicЧ,˷ܵһ,ٴεЧ׳쳣
     */
    public void completeSubscribe() throws MetaClientException;


    /**
     * شʹõoffset洢ɹ
     * 
     * @return
     */
    public OffsetStorage getOffsetStorage();


    /**
     * ֹͣ
     */
    public void shutdown() throws MetaClientException;


    /**
     * 
     * 
     * @return
     */
    public ConsumerConfig getConsumerConfig();

    /**
     * Returns current RejectConsumptionHandler
     *
     * @return
     */
    public RejectConsumptionHandler getRejectConsumptionHandler();

    /**
     * Sets RejectConsumptionHandler for this consumer.
     *
     * @param rejectConsumptionHandler
     */
    public void setRejectConsumptionHandler(RejectConsumptionHandler rejectConsumptionHandler);
}